#include <bits/stdc++.h>
using namespace std;

int const maxn = 1300300;
int const mod = 998244353;

int prod(int a, int b) {
  return (long long) a * b % mod;
}

void add(int &a, int b) {
  if ((a += b) >= mod) {
    a -= mod;
  }
}

int inv[maxn];
int fact[maxn];
int invfact[maxn];

void precalc() {
  inv[1] = 1;
  for (int i = 2; i < maxn; ++i) {
    inv[i] = prod(inv[mod % i], mod - mod / i);
    assert(prod(inv[i], i) == 1);
  }
  fact[0] = 1;
  invfact[0] = 1;
  for (int i = 1; i < maxn; ++i) {
    fact[i] = prod(fact[i - 1], i);
    invfact[i] = prod(invfact[i - 1], inv[i]);
    assert(prod(fact[i], invfact[i]) == 1);
  }
}

int Cnk(int n, int k) {
  assert(n >= 0);
  assert(k >= 0);
  assert(k <= n);
  return prod(fact[n], prod(invfact[k], invfact[n - k]));
}

void solve() {
  int n, k;
  scanf("%d%d", &n, &k);
  int answer = Cnk(n + k - 1, k - 1);
  cout << answer << '\n';
}

int main() {
  precalc();
  int tests = 1;
  scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
