import random
import math
random.seed("basic04/bombs")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([[4, 1], [4, 0], [3, 3], [2, 2]], [[0, 0, 4]])

    def generate_min_tests(self):
        self.print_test([[0, 0]], [[0, 0, 1]])
        self.print_test([[1, 0]], [[0, 0, 1]])
        self.print_test([[1, 1]], [[0, 0, 1]])
        self.print_test([[1, 1]], [[0, 0, 2]])
        self.print_test([[1, 1], [1, 1], [0, 0], [1, 0], [0, 1], [0, 0]], [[0, 0, 2]])

    def generate_hand_tests(self):
        pass

    def generate_random_test(self, maxn, maxm, maxc, maxr=None):
        a = []
        for i in range(maxn):
            x = random.randint(0, maxc)
            y = random.randint(0, maxc)
            a.append([x, y])
        b = []
        rs = [10, 100, 1000]
        for i in range(maxm):
            x = random.randint(0, maxc)
            y = random.randint(0, maxc)
            t = random.randint(0, 2)
            if maxr is None:
                r = random.randint(1, rs[t])
            else:
                r = maxr
            b.append([x, y, r])
        self.print_test(a, b)

    def generate_max_tests(self, maxn, maxm, maxc, maxr):
        a = [[0, 0] for _ in range(maxn)]
        b = [[0, 0, 1] for _ in range(maxm)]
        self.print_test(a, b)

        a = [[10**4, 10**4] for _ in range(maxn)]
        b = [[9000, 9000, 1000] for _ in range(maxm)]
        self.print_test(a, b)

        a = [[10**4, 10**4] for _ in range(maxn)]
        b = [[9500, 9500, 1000] for _ in range(maxm)]
        self.print_test(a, b)

        a = []
        for i in range(maxn):
            x = (random.randint(0, 100) + 700)
            y = (random.randint(0, 100) + 700)
            a.append([x, y])
        b = []
        for i in range(maxm):
            x = random.randint(0, 100)
            y = random.randint(0, 100)
            r = maxr
            b.append([x, y, r])
        self.print_test(a, b)


    def print_test(self, a, b):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(a), file=test_file)
        print('\n'.join(' '.join(str(e) for e in el) for el in a), file=test_file)
        print(len(b), file=test_file)
        print('\n'.join(' '.join(str(e) for e in el) for el in b), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        #ns = [3, 5, 10, 100, 1000, 10**6]
        #ms = [1, 2, 5, 10, 100, 10**4]
        #maxc = [10, 10**4]
        #for n in ns:
        #    for m in ms:
        #        for c in maxc:
        #            self.generate_random_test(n, m, c)
        #self.generate_max_tests(10**6, 10**4, 10**4, 1000)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
