#include <bits/stdc++.h>
#define link _link
using namespace std;

int const N = 500500;
int const A = 276;
int const LOG = 20;

int n;
char s[N];
int sa[N];

void build_sa() {
  static int start[N], col[N], col1[N], sa1[N];
  for (int i = 0; i < n; ++i) {
    ++start[1 + s[i]];
  }
  for (int i = 1; i < A; ++i) {
    start[i] += start[i - 1];
  }
  for (int i = 0; i < n; ++i) {
    sa[start[(int)s[i]]++] = i;
    col[i] = s[i];
  }
  copy(s, s + n, col);
  for (int i = 0; i < n; ++i) {
    --start[(int)s[i]];
  }
  for (int h = 1; 1 << h < n; ++h) {
    for (int i = 0; i < n; ++i) {
      int x = (sa[i] + n - h) % n;
      sa1[start[col[x]]++] = x;
    }
    int lc = 0;
    start[lc] = 0;
    col1[sa1[0]] = lc;
    for (int i = 0; i < n - 1; ++i) {
      int j = i + 1;
      if (col[sa1[i]] != col[sa1[j]] || col[(sa1[i] + h) % n] != col[(sa1[j] + h) % n]) {
        start[++lc] = j;
      }
      col1[sa1[j]] = lc;
    }
    copy(sa1, sa1 + n, sa);
    copy(col1, col1 + n, col);
  }
}

int where[N];
int blog[N];
int lcp[LOG][N];
int mipos[LOG][N], mapos[LOG][N];

void build_lcp() {
  for (int i = 0; i < n; ++i) {
    where[sa[i]] = i;
  }
  int x = 0;
  for (int i = 0; i < n; ++i) {
    if (where[i] == n - 1) {
      x = 0;
    } else {
      if (x > 0) {
        --x;
      }
      int j = sa[where[i] + 1];
      while (s[i + x] == s[j + x]) {
        ++x;
      }
      lcp[0][where[i]] = x;
    }
  }
  for (int i = 0; i < n; ++i) {
    mipos[0][i] = sa[i];
    mapos[0][i] = sa[i];
  }
  for (int i = 1; (1 << i) < n; ++i) {
    for (int j = 0; j + (1 << i) < n; ++j) {
      lcp[i][j] = min(lcp[i - 1][j], lcp[i - 1][j + (1 << (i - 1))]);
      mipos[i][j] = min(mipos[i - 1][j], mipos[i - 1][j + (1 << (i - 1))]);
      mapos[i][j] = max(mapos[i - 1][j], mapos[i - 1][j + (1 << (i - 1))]);
    }
  }
  blog[1] = 0;
  for (int i = 2; i <= n; ++i) {
    blog[i] = 1 + blog[i >> 1];
  }
}

int get_lcp(int i, int j) {
  assert(i != j);
  if (i > j) {
    swap(i, j);
  }
  int x = blog[j - i];
  return min(lcp[x][i], lcp[x][j - (1 << x)]);
}

int min_pos(int i, int j) {
  assert(i != j);
  if (i > j) {
    swap(i, j);
  }
  int x = blog[j - i];
  return min(mipos[x][i], mipos[x][j - (1 << x)]);
}

int max_pos(int i, int j) {
  assert(i != j);
  if (i > j) {
    swap(i, j);
  }
  int x = blog[j - i];
  return max(mapos[x][i], mapos[x][j - (1 << x)]);
}

void solve() {
  scanf("%s", s);
  n = strlen(s);
  s[n++] = '!';
  build_sa();
  build_lcp();
  long long ans = n - 1;
  for (int i = 0; i < n - 1; ++i) {
    int len = lcp[0][i];
    if (len == 0) {
      continue;
    }
    int l = -1, r = i;
    while (r - l > 1) {
      int j = (l + r) / 2;
      (get_lcp(j, i + 1) >= len ? r : l) = j;
    }
    int from = r;
    l = i + 1, r = n;
    while (r - l > 1) {
      int j = (l + r) / 2;
      (get_lcp(i, j) >= len ? l : r) = j;
    }
    int to = l;
    int maxlen = len + (max_pos(from, to + 1) - min_pos(from, to + 1));
    ans = max(ans, (long long)len * len + maxlen);
  }
  cout << ans << '\n';
}

int main() {
  int tests = 1;
  //scanf("%d", &tests);
  for (int i = 0; i < tests; ++i) {
    solve();
  }
}
