#include "testlib.h"
#include <vector>
#include <iostream>
#include <string>
#include <unordered_set>

using namespace std;


template<typename T>
string to_string(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}

const int MAXX = 1e6;

template<typename T>
string check(T &ouf, vector<int>& a, int& r, int& cnt) 
{
    int ans = ouf.readInt();
    int n = a.size();
    unordered_set<int> used;
    cnt = 0;
    for (int i = 0; i < n; i++)
    {
        long long b = ouf.readInt();
        if (used.find(b) == used.end())
            cnt++;
        if (abs(b - a[i]) > r)
            return "incorrect b[" + to_string(i + 1) + "];";
        used.insert(b);
    }
    if (ans != cnt)
        return "Answer doesn't fit to sertificate: " + to_string(ans) + "expected, but " + to_string(cnt) + "found";
    return "ok";
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
    
    
    int n = inf.readInt();
    int r = inf.readInt();
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = inf.readInt();


    int jcnt, ccnt;
    string cans = check(ouf, a, r, ccnt);
    string jans = check(ans, a, r, jcnt);
    quitif(cans != "ok", _wa, cans.c_str());
    quitif(jans != "ok", _fail, jans.c_str());
    quitif(jcnt > ccnt, _wa, "Not optimal answer %d expected, %d found", jcnt, ccnt);
    quitif(jcnt < ccnt, _fail, "Jury has not optimal answer %d expected, %d found", jcnt, ccnt);
    quitf(_ok, "%d", jcnt);
    return 0;
}