import random
import math
random.seed("basic02/gasorposorp")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([1, 5, 3, 5, 4])

    def generate_min_tests(self):
        self.print_test([1])
        self.print_test([10**9])
        self.print_test([1, 1])
        self.print_test([10**9, 10**9])
        self.print_test([1, 2])
        self.print_test([2, 1])
        self.print_test([1, 3])
        self.print_test([3, 1])
        self.print_test([5, 100])

    def generate_hand_tests(self):
        self.print_test([100, 1, 2, 3])

    def generate_random_test(self, maxn, maxdv):
        l = random.randint(1, 10**9 - maxdv + 1)
        r = l + maxdv - 1
        a = []
        for i in range(maxn):
            a.append(random.randint(l, r))
        self.print_test(a)

    def generate_max_tests(self, maxn, maxv):
        self.print_test([1] * maxn)
        a = [(maxv - i) for i in range(maxn)]
        random.shuffle(a)
        self.print_test(a)
        a = []
        iters = maxn // 100
        for i in range(iters):
            l = (maxv // iters) * i + 1
            r = (maxv // iters) * i + 100
            for j in range(100):
                a.append(random.randint(l, r))
        random.shuffle(a)
        self.print_test(a)

    def print_test(self, a):
        self.test_number += 1
        print('Generating test #%d' % self.test_number)

        test_name = "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, 'w')
        print(len(a), file=test_file)
        print(' '.join(map(str, a)), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        ns = [1, 3, 5, 10, 50, 100, 10**3, 10**4, 10**5]
        dvs = [1, 10, 100, 10**3, 10**5, 10**9]
        for n in ns:
            for dv in dvs:
                self.generate_random_test(n, dv)
        self.generate_max_tests(10**5, 10**9)

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
