#include "testlib.h"
#include <map>
#include <set>
#include <unordered_set>
#include <queue>
#include <iostream>

using namespace std;

string s;

int read_answer(InStream &stream) {
    string t = stream.readString();
    stream.readEoln();

    if (t.length() != s.length()) {
        stream.quitf(_wa, "length of the string must not be changed\n");
    }

    for (int i = 2; i < t.length(); ++i) {
        if (t[i - 2] == t[i] && t[i - 1] == t[i]) {
            stream.quitf(_wa, "must not contain three equal chars in a row\n");
        }
    }

    vector<int> cnt('z' + 1);
    for (char c : t) {
        cnt[c]++;
    }
    for (char c = 'a'; c <= 'z'; ++c) {
        if (cnt[c] > t.length() / 2) {
            stream.quitf(_wa, "'%c' met too often\n", c);
        }
    }

    int changes = 0;
    for (int i = 0; i < t.length(); ++i) {
        if (t[i] != s[i]) changes++;
    }

    return changes;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    s = inf.readString();

    int expected = read_answer(ans);
    int actual = read_answer(ouf);
    if (expected < actual)
        quitf(_wa, "jury has better answer\n");
    else if (expected == actual)
        quitf(_ok, "correct\n");
    else
        quitf(_fail, "participant has found better answer\n");
}