#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

const int MAXN = 1e5;
const int MAXX = 1e4;
int cur_test = -1;

string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}

void write_test(vector<int> a) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    printf("%d\n", (int)a.size());
    for (int i = 0; i < (int)a.size(); i++)
        printf("%d%c", a[i], (i < (int)a.size() - 1) ? ' ' : '\n');
}

void gen_rand(int n, int maxx)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = rnd.next(1, maxx);
    write_test(a);    
}

void gen_half(int n, int x)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = x * rnd.next(1, 2);
    write_test(a);    
}

void gen_small_ans(int n, int maxx)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = rnd.next(1, maxx / 10);
    a[rnd.next(n)] = maxx;
    write_test(a);    
}

void gen_progression(int n, int from, int d)
{
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        a[i] = from + min(i * d, MAXX - from);
    shuffle(a.begin(), a.end());
    write_test(a);    
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    gen_rand(10, 10);
    gen_half(10, 2);
    gen_small_ans(15, 100);
    gen_progression(20, 1, 1);
    for (int i = 100; i <= MAXN; i *= 10) 
    {       
        gen_rand(rnd.next(i/2, i), MAXX);
        gen_rand(rnd.next(i/2, i), MAXX);
        gen_half(rnd.next(i/2, i), rnd.next(min(i, MAXX)/4, min(i, MAXX)/2));
        gen_small_ans(rnd.next(i/2, i), min(i, MAXX));
        gen_progression(rnd.next(i/2, i), rnd.next(1, i), rnd.next(1, 10));
    }
    gen_rand(MAXN, MAXX);
    gen_half(MAXN, MAXX / 2);
    gen_small_ans(MAXN, MAXX);
    gen_progression(MAXN, 1, 1);
    gen_progression(MAXN, 100, 3);
    return 0;
}